#if !defined(CD_VIS_MATRIX_APP)
#define CD_VIS_MATRIX_APP

#include "DMatrixBasic.h"
#include "DMatrixStat.h"

////////////////////////////////////////////////////////////////////////////
//  
//  CLASS:
//      CVisDVector
//  
////////////////////////////////////////////////////////////////////////////
class CDVectorApp : public virtual CDVectorBasic, public virtual CDVectorStat
{
public:
    // Constructors (default destructor and copy constructor)
    CDVectorApp(void):CVisDVector(){};
    CDVectorApp(int length, double *storage = 0):CVisDVector(length,storage) {};
    CDVectorApp(const CDVectorApp &vec):CVisDVector(vec) {};

    // Assignment
    CDVectorApp& operator=(const CVisDVector &vIn) {CVisDVector& vTmp = *this; vTmp = vIn; return *this; };
    CDVectorApp& operator=(double value) {CVisDVector& vTmp = *this; vTmp = value; return *this; };
};


////////////////////////////////////////////////////////////////////////////
//  
//  CLASS:
//      CVisDMatrix
//  
////////////////////////////////////////////////////////////////////////////
class CDMatrixApp : public virtual CDMatrixBasic, public virtual CDMatrixStat
{
public:
    // Constructors (default destructor and copy constructor)
    CDMatrixApp(void):CVisDMatrix(){};
    CDMatrixApp(int rows, int cols, double *storage = 0):CVisDMatrix(rows,cols,storage) {};
    CDMatrixApp(const CDMatrixApp &mat):CVisDMatrix(mat) {};

    // Assignment
    CDMatrixApp& operator=(const CVisDMatrix &mat) {CVisDMatrix& mTmp = *this; mTmp = mat; return *this; };;
    CDMatrixApp& operator=(double value) {CVisDMatrix& mTmp = *this; mTmp = value; return *this; };


};


#endif // CD_VIS_MATRIX_