#if !defined(CD_VIS_MATRIX_STAT)
#define CD_VIS_MATRIX_STAT

#include "DMatrixBasic.h"

////////////////////////////////////////////////////////////////////////////
//  
//  CLASS:
//      CVisDVector
//  
////////////////////////////////////////////////////////////////////////////
class CDVectorStat : public virtual CDVectorBasic
{
public:
    // Constructors (default destructor and copy constructor)
    CDVectorStat(void):CVisDVector(){};
    CDVectorStat(int length, double *storage = 0):CVisDVector(length,storage) {};
    CDVectorStat(const CDVectorStat &vec):CVisDVector(vec) {};

    // Assignment
    CDVectorStat& operator=(const CDVectorStat &vIn) {CVisDVector& vTmp = *this; vTmp = vIn; return *this; };
    CDVectorStat& operator=(double value) {CVisDVector& vTmp = *this; vTmp = value; return *this; };


	double Max();
	double Mean();
	double Min();

	double Skewness();

	double Std();
	double Sum();

	double Var();
};


////////////////////////////////////////////////////////////////////////////
//  
//  CLASS:
//      CVisDMatrix
//  
////////////////////////////////////////////////////////////////////////////
class CDMatrixStat : public virtual CDMatrixBasic
{
public:
    // Constructors (default destructor and copy constructor)
    CDMatrixStat(void):CVisDMatrix(){};
    CDMatrixStat(int rows, int cols, double *storage = 0):CVisDMatrix(rows,cols,storage) {};
    CDMatrixStat(const CDMatrixStat &mat):CVisDMatrix(mat) {};

    // Assignment
    CDMatrixStat& operator=(const CDMatrixStat &mat) {CVisDMatrix& mTmp = *this; mTmp = mat; return *this; }
    CDMatrixStat& operator=(double value) {CVisDMatrix& mTmp = *this; mTmp = value; return *this; }


	double Mean();
	void MeanCol(CDVectorStat& vMean);

	double Std();
	void StdCol(CDVectorStat& vStd);

	double Sum();
	void SumCol(CDVectorStat& vSum);

	double Var();
	void VarCol(CDVectorStat& vVar);

	void OneWayANOVA(double& dZ, int& nDFModel, int& nDFError);
	void TTest(const int iCol1,const int iCol2, double& dZ, int& nDF);
};


#endif // CD_VIS_MATRIX_Stat